/*

	Ad262Sop Library Source (c) 1996, Park Jeenhong

	This source file can freely be used for your adlib card programming.
	Compile : Turbo C++ 3.0, Borland International

*/

#include <dos.h>

/* percussive voice numbers: */
#define BD			6
#define SD			7
#define TOM			8
#define CYMB			9
#define HIHAT			10

#define MAX_VOLUME		0x7f
#define LOG2_VOLUME		7			/* log2( MAX_VOLUME) */
#define MAX_PITCH		0xC7
#define MID_PITCH		0x64

#define MID_C			60			/* MIDI standard mid C */
#define CHIP_MID_C		48			/* sound chip mid C */
#define NR_NOTES		96			/* # of notes we can play on chip */


#define N_V			near
#define TOM_PITCH		36			/* best frequency, in range of 0 to 95 */
#define TOM_TO_SD		7			/* 7 half-tones between voice 7 & 8 */
#define SD_PITCH		(TOM_PITCH + TOM_TO_SD)

#define	GENADDR		3

#define	LOAD			0
#define	SAVE			1

#define	maxVoices		20
#define	YMB_SIZE		69

static unsigned char	N_V	Stereo[]={
	0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30,
	0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x00
};

static unsigned char	N_V	OP4[]={
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};

static const unsigned char N_V	SlotX[]={
	0, 1, 2, 8, 9, 10, 16, 17, 18, 0, 0, 0, 1, 2, 8, 9, 10, 16, 17, 18,
	0, 1, 2, 8, 9, 10, 16, 20, 18, 21, 17, 0, 1, 2, 8, 9, 10, 16, 17, 18
};

static const unsigned char N_V	FreqH[]={
	1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2
};

static const unsigned char N_V	FreqL[]={
	0x59, 0x6D, 0x83, 0x9A, 0xB3, 0xCC,
	0xE8, 0x05, 0x23, 0x44, 0x67, 0x8B
};

static const int N_V			FreqP[]={
	0x13, 0x14, 0x16, 0x18, 0x19, 0x1B,
	0x1C, 0x1D, 0x20, 0x23, 0x23, 0x25
};

static const int N_V			FreqM[]={
	0x11, 0x13, 0x14, 0x16, 0x18, 0x19,
	0x1B, 0x1C, 0x1D, 0x20, 0x22, 0x23
};

static const unsigned char N_V	VolReg[]={
	0x43, 0x44, 0x45, 0x4B, 0x4C, 0x4D, 0x53, 0x54, 0x55, 0, 0,
	0x43, 0x44, 0x45, 0x4B, 0x4C, 0x4D, 0x53, 0x54, 0x52, 0x55, 0x51
};

static const unsigned char N_V	MOD12[]={
	0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11,
	0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11,
	0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11,
	0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11,
	0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11,
	0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11,
	0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11,
	0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11,
	0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11,
	0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11,
	0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11
};

static const unsigned char N_V	DIV12[]={
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
	8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,
	12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
	16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16,
	20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
	24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,
	32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32,
	36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36
};

static unsigned char	N_V	ymbuf[2*YMB_SIZE];

static int	N_V 	modeWaveSel;		/* != 0 if used with the 'wave-select' parameters */
static int	N_V	genAddr_SOP;

static char N_V voiceNote [20];          /* pitch of last note-on of each voice */
static char N_V voiceKeyOn [20];     /* state of keyOn bit of each voice */
static char N_V vPitchBend [20]; /* current pitch bend of each voice */
static unsigned char N_V Ksl[20], Ksl2[20], Ksl2V[20];
static unsigned char N_V VoiceVolume[20], OP_MASK;

static char	N_V percussion;		/* percussion mode parameter */

/*----------------------------------------------------------
   Function prototypes.
*/

static void SoundWarmInit();
static void UpdateFNums (int);
static int BoardInstalled();
static void near SndOutput1 (int addr, int value);
static void near SndOutput3 (int addr, int value);
static void near SEND_INS(int base_addr, unsigned char *value, int mode);

void NoteOff_SOP(unsigned);

void SetMode_SOP (int mode)
{
	if(mode) {
		/* set the frequency for the last 4 percussion voices: */
		voiceNote [TOM] = TOM_PITCH;
		vPitchBend [TOM] = 0;
		UpdateFNums (TOM);

		voiceNote [SD] = SD_PITCH;
		vPitchBend [SD] = 0;
		UpdateFNums (SD);
	}

	percussion = mode;

	SndOutput1(0xBD, (percussion ? 0x20 : 0));
}   /* SetMode() */


int SoundColdInit_SOP (unsigned port)
{
	int i, hardware;
	unsigned PORT_NUM[]={
		0x388, 0x220, 0x240, 0x260, 0x280,
		0x228, 0x248, 0x268, 0x288
	};

	asm {
		jmp NET
		db	'AdLib 262 Library for SOP - Copyright (c) 1996, Park Jeenhong', 0
	}

NET:	if(port!=0) {
		genAddr_SOP=port;
		hardware =  BoardInstalled();
	}
	else {
		hardware=0;
		for(i=0; i<9; i++) {
			genAddr_SOP=PORT_NUM[i];
			hardware =  BoardInstalled();
			if(hardware) break;
		}
		if(!hardware) {
			genAddr_SOP=0x388;
			hardware =  BoardInstalled();
		}
	}

	SoundWarmInit();

	return hardware;
}   /* SoundColdInit() */

static void SoundWarmInit()
{
	int i;

	for(i=1; i<=0xF5; i++) {
		SndOutput1(i, 0);	/* clear all registers */
		SndOutput3(i, 0);
	}

	SndOutput1(4, 6);				/* mask T1 & T2 */

	OP_MASK=0;
	SndOutput3(5, 1);				/* YMF-262M Mode */
	SndOutput3(4, 0);

	for (i = 0; i < 20; i++)  {      /* pitch bend for each voice = no detune */
		vPitchBend [i] = 0;
		voiceKeyOn [i] = 0;
		voiceNote [i] = MID_C;
		Ksl2V[i] = 0;
	}

	SetMode_SOP (0);                /* melodic mode */

	SndOutput1(0x08, 0);
	SndOutput1(1, 0x20);
}   /* SoundWarmInit() */




/*
------------------------------------------------------------------------
	static functions ...
------------------------------------------------------------------------
*/


static void UpdateFNums (int chan)
{
	int OFFSET=MOD12[voiceNote[chan]], pitch, pitch2;

	if(chan >= maxVoices) return;

	pitch=FreqL[OFFSET]+vPitchBend[chan];

	if(OFFSET==7) {
		pitch2=FreqH[OFFSET]-(pitch<0);
		if(pitch<0) pitch=0x100+pitch;
	}
	else pitch2=FreqH[OFFSET]+(pitch>=0x100);

	SndOutput1(0xA0+chan, pitch);
	SndOutput1(0xB0+chan, DIV12[voiceNote[chan]]|pitch2);
}



/*
	Return 0 if board is not installed.  The chip's timers are used to
	determined if an Ad Lib card is present.  When being used, the timers
	place specific values in the status register.  If we do not read the
	correct values from the status register, then we can assume that no
	board is present.
*/
static int BoardInstalled()
{
	unsigned t1, t2, i;

	SndOutput1(4, 0x60);    /* mask T1 & T2 */
	SndOutput1(4, 0x80);    /* reset IRQ */
	t1 = inp (genAddr_SOP);     /* read status register */
	SndOutput1(2, 0xff);    /* set timer-1 latch */
	SndOutput1(4, 0x21);    /* unmask & start T1 */

	for (i = 0; i < 200; i++)   /* 100 uSec delay for timer-1 overflow */
		inp (genAddr_SOP);

	t2 = inp (genAddr_SOP);     /* read status register */
	SndOutput1(4, 0x60);
	SndOutput1(4, 0x80);

	return (t1 & 0xE0) == 0 && (t2 & 0xE0) == 0xC0;
}


/***************************************************************************/

static void near SndOutput1(int addr, int value)
{
	if(addr>=0xB0) ymbuf[addr-0xB0] = value;

	_DX=genAddr_SOP;

	asm {
		mov	al, byte ptr addr
		out	dx, al

		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx

		inc	dx
		mov	al, byte ptr value
		out	dx, al

		mov	cx, 6
	}

L11:	asm {
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx
		loop	L11
	}
}

static void near SndOutput3(int addr, int value)
{
	if(addr>=0xB0) ymbuf[YMB_SIZE-0xB0+addr] = value;

	_DX=genAddr_SOP+2;

	asm {
		mov	al, byte ptr addr
		out	dx, al

		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx

		inc	dx
		mov	al, byte ptr value
		out	dx, al

		mov	cx, 6
	}

L12:	asm {
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx
		loop	L12
	}
}

static void near SEND_INS(int base_addr, unsigned char *value, int mode)
{
	_DX=genAddr_SOP+(unsigned)(mode<<1);
	_DI=base_addr;

	asm {
		push	ds
		lds	si, value
		mov	cx, 4
	}
LTX:	asm {
		mov	ax, di
		out	dx, al

		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx

		inc	dx
		lodsb
		out	dx, al
		dec	dx

		push	cx
		mov	cx, 6
	}
L14:	asm {
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx

		loop	L14

		pop	cx

		add	di, 0x20
		loop	LTX

		add	di, 0x40

		mov	ax, di
		out	dx, al

		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx

		inc	dx
		lodsb
		and	al, 0x07
		out	dx, al

		mov	cx, 6
	}
L15:	asm {
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx

		loop	L15

		pop	ds
	}
}

void SetYM_262_SOP(int VX)
{
	SndOutput3(5, VX);
	SndOutput3(4, 0);
}

int GetStereoPan_SOP(int chan, int mode)
{
	register int i;

	if(mode==0) return (int)(Stereo[chan]>>4);
	return 3;
}

void SetStereoPan_SOP(int chan, int value)
{
	int PAN[]={0x20, 0x30, 0x10};

	if(chan >= maxVoices) return;

	Stereo[chan]=(unsigned char)(value=PAN[value]);

	_DX=genAddr_SOP;

	if(chan<9) _CX=chan;
	else {
		if(chan<11) _CX=17-chan;
		else {
			_CX=chan-11;
			asm	add	dx, 2;
		}
	}

	value |= ((chan>=11) ? ymbuf[YMB_SIZE+0x10+_CX] & 0xCF : ymbuf[_CX+0x10] & 0xCF);

	if(OP4[chan]) {
		_BL=((chan>=11) ? ymbuf[YMB_SIZE+0x10+_CX] : ymbuf[_CX+0x10])&0x0F;
		asm {
			push	cx
			mov	al, cl
			add	al, 0xC3
			out	dx, al

			in	al, dx
			in	al, dx
			in	al, dx
			in	al, dx

			in	al, dx
			in	al, dx

			inc	dx
			mov	al, byte ptr value
			and	al, 0xF0
			or	al, bl
			out	dx, al
			dec	dx

			mov	cx, 6
		}
L17:		asm {
			in	al, dx
			in	al, dx
			in	al, dx
			in	al, dx

			in	al, dx
			in	al, dx

			loop	L17
			pop	cx
		}
	}

	asm {
		mov	al, cl
		add	al, 0xC0
		out	dx, al

		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx

		inc	dx
		mov	al, byte ptr value
		out	dx, al

		mov	cx, 6
	}
L16:	asm {
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx

		loop	L16
	}
}

void SetVoiceVolume_SOP(unsigned chan, unsigned vol)
{
	_SI=chan;

	if(_SI >= maxVoices) return;
	if(_SI>2 && OP4[_SI-3]) return;

	if(vol > MAX_VOLUME) vol = MAX_VOLUME;

	VoiceVolume[_SI]=vol;

	if(Ksl2V[_SI]) {
		_DI = 63 - (unsigned)(((63 - (_BL=Ksl2[_SI])&0x3F) * vol + (MAX_VOLUME + 1) / 2) >> 7);

		if(_SI>=11) SndOutput3(VolReg[_SI-11]-3, _BL&0xC0|_DI);
		else SndOutput1((percussion ? VolReg[_SI+11] : VolReg[_SI])-3, _BL&0xC0|_DI);

		if(OP4[_SI]) {
			_SI += 3;
			_DI = 63 - (unsigned)(((63 - (_BL=Ksl[_SI])&0x3F) * vol + (MAX_VOLUME + 1) / 2) >> 7);

			if(_SI>=11) SndOutput3(VolReg[_SI-11], _BL&0xC0|_DI);
			else SndOutput1(VolReg[_SI], _BL&0xC0|_DI);

			if(Ksl2V[_SI]) {
				_DI = 63 - (unsigned)(((63 - (_BL=Ksl2[_SI])&0x3F) * vol + (MAX_VOLUME + 1) / 2) >> 7);

				if(_SI>=11) SndOutput3(VolReg[_SI-11]-3, _BL&0xC0|_DI);
				else SndOutput1(VolReg[_SI]-3, _BL&0xC0|_DI);
			}
		}
		else {
			_DI = 63 - (unsigned)(((63 - (_BL=Ksl[_SI])&0x3F) * vol + (MAX_VOLUME + 1) / 2) >> 7);

			if(_SI>=11) SndOutput3(VolReg[_SI-11], _BL&0xC0|_DI);
			else SndOutput1((percussion ? VolReg[_SI+11] : VolReg[_SI]), _BL&0xC0|_DI);
		}
	}
	else {
		if(OP4[_SI]) {
			_DI = 63 - (unsigned)(((63 - (_BL=Ksl[_SI+3])&0x3F) * vol + (MAX_VOLUME + 1) / 2) >> 7);

			if(_SI>=11) SndOutput3(VolReg[_SI+3-11], _BL&0xC0|_DI);
			else SndOutput1(VolReg[_SI+3], _BL&0xC0|_DI);

			if(Ksl2V[_SI+3]) {
				_DI = 63 - (unsigned)(((63 - (_BL=Ksl[_SI])&0x3F) * vol + (MAX_VOLUME + 1) / 2) >> 7);

				if(_SI>=11) SndOutput3(VolReg[_SI-11], _BL&0xC0|_DI);
				else SndOutput1(VolReg[_SI], _BL&0xC0|_DI);
			}
		}
		else {
			_DI = 63 - (unsigned)(((63 - (_BL=Ksl[_SI])&0x3F) * vol + (MAX_VOLUME + 1) / 2) >> 7);

			if(_SI>=11) SndOutput3(VolReg[_SI-11], _BL&0xC0|_DI);
			else SndOutput1((percussion ? VolReg[_SI+11] : VolReg[_SI]), _BL&0xC0|_DI);
		}
	}
}

void SetVoiceTimbre_SOP(unsigned chan, void *array)
{
	int i;

	_SI=chan;
	if(_SI >= maxVoices) return;
	if(_SI>2 && OP4[_SI-3]) return;

	asm {
		cmp	percussion, 0
		je	L20
		mov	bx, chan
		mov	al, byte ptr SlotX[bx+20]
		xor	ah, ah
		mov	si, ax
		jmp	OUT
	}
L20:	asm {
		mov	bx, chan
		mov	al, byte ptr SlotX[bx]
		xor	ah, ah
		mov	si, ax
	}

OUT:	Ksl2V[chan]=((_DI=((unsigned char *)array)[5]&0x0F)&0x01);

	asm {
		mov	ax, chan
		cmp	ax, 8
		ja	CH8
		add	al, 0xC0
		mov	i, ax
		jmp	OK
	}
CH8:	asm {
		cmp	ax, 10
		ja	CHA
		mov	cx, 0xC0 + 17
		sub	cl, al
		mov	i, cx
		jmp	OK
	}
CHA:	asm {
		add	al, 0xC0 - 11
		mov	i, ax
	}

	SndOutput3(i, 0);

	if(OP4[chan]) {
		SEND_INS(0x28+_SI, &((unsigned char *)array)[11], 1);
		SEND_INS(0x2B+_SI, &((unsigned char *)array)[17], 1);
		asm {
			les	bx, array
			mov	al, byte ptr es:[bx+12]
			mov	ah, byte ptr es:[bx+18]
			mov	cl, byte ptr es:[bx+16]
			mov	dx, cx
			and	cl, 1
			mov	bx, chan
			and	dl, 0x0F
			or	dl, byte ptr Stereo[bx]
			mov	byte ptr Ksl[bx+3], ah
			mov	byte ptr Ksl2[bx+3], al
			mov	byte ptr Ksl2V[bx+3], cl
			add	bx, 0xB8
		}
		SndOutput3(_BX, _DX);
	}

	SEND_INS(0x20+_SI, (unsigned char *)array, 1);
	SEND_INS(0x23+_SI, &((unsigned char *)array)[6], 1);
	asm {
		les	bx, array
		mov	al, byte ptr es:[bx+1]
		mov	ah, byte ptr es:[bx+7]
		mov	si, chan
		mov	byte ptr Ksl[si], ah
		mov	byte ptr Ksl2[si], al
	}
	SetVoiceVolume_SOP(_SI, VoiceVolume[_SI]);
	SndOutput3(i, _DI|Stereo[_SI]);
	return;

OK:	SndOutput1(i, 0);

	if(OP4[chan]) {
		SEND_INS(0x28+_SI, &((unsigned char *)array)[11], 0);
		SEND_INS(0x2B+_SI, &((unsigned char *)array)[17], 0);
		asm {
			les	bx, array
			mov	al, byte ptr es:[bx+12]
			mov	ah, byte ptr es:[bx+18]
			mov	cl, byte ptr es:[bx+16]
			mov	dx, cx
			and	cl, 1
			mov	bx, chan
			and	dl, 0x0F
			or	dl, byte ptr Stereo[bx]
			mov	byte ptr Ksl[bx+3], ah
			mov	byte ptr Ksl2[bx+3], al
			mov	byte ptr Ksl2V[bx+3], cl
			add	bx, 0xC3
		}
		SndOutput1(_BX, _DX);
	}

	SEND_INS(0x20+_SI, (unsigned char *)array, 0);
	if(percussion && chan>BD) {
		asm {
			les	bx, array
			mov	al, byte ptr es:[bx+1]
			mov	si, chan
			mov	byte ptr Ksl[si], al
			mov	byte ptr Ksl2V[si], 0
		}
	}
	else {
		SEND_INS(0x23+_SI, &((unsigned char *)array)[6], 0);
		asm {
			les	bx, array
			mov	al, byte ptr es:[bx+1]
			mov	ah, byte ptr es:[bx+7]
			mov	si, chan
			mov	byte ptr Ksl[si], ah
			mov	byte ptr Ksl2[si], al
		}
	}
	SetVoiceVolume_SOP(_SI, VoiceVolume[_SI]);
	SndOutput1(i, _DI|Stereo[_SI]);
}

void SetVoicePitch_SOP(unsigned chan, int pitch)
{
	int pitchL;

	_SI=MOD12[(_BX=voiceNote[chan])];
	_DI=DIV12[_BX];

	if(chan >= maxVoices || pitch < 0 || pitch > 200) return;

	if(pitch>=100) vPitchBend[chan]=FreqP[_SI]*(pitch-100)/100;
	else vPitchBend[chan]=FreqM[_SI]*(pitch-100)/100;

	_DX=FreqL[_SI]+vPitchBend[chan];
	pitchL=_DL;

	if(_SI==7) {
		asm {
			xor	ah, ah
			mov	al, byte ptr FreqH[si]
			shl	dh, 1
			sbb	al, 0
			or	di, ax
		}
	}
	else {
		asm {
			xor	ah, ah
			mov	al, byte ptr FreqH[si]
			add	al, dh
			or	di, ax
		}
	}

	_SI=chan;

	if(percussion && _SI>=BD && _SI<=HIHAT) {
		if(_SI==BD) {
			SndOutput1(0xA6, pitchL);
			SndOutput1(0xB6, _DI);
		}
	}
	else {
		if(_SI>=11) {
			SndOutput3(0xA0-11+_SI, pitchL);
			SndOutput3(0xB0-11+_SI, voiceKeyOn[_SI]|_DI);
		}
		else {
			SndOutput1(0xA0+_SI, pitchL);
			SndOutput1(0xB0+_SI, voiceKeyOn[_SI]|_DI);
		}
	}
}

void SetVoicePitch2_SOP(unsigned chan, int pitch)
{
	int pitchL;

	_SI=MOD12[(_BX=voiceNote[chan])];
	_DI=DIV12[_BX];

	if(chan >= maxVoices) return;

	_DX=FreqL[_SI]+pitch;
	pitchL=_DL;

	if(_SI==7) {
		asm {
			xor	ah, ah
			mov	al, byte ptr FreqH[si]
			shl	dh, 1
			sbb	al, 0
			or	di, ax
		}
	}
	else {
		asm {
			xor	ah, ah
			mov	al, byte ptr FreqH[si]
			add	al, dh
			or	di, ax
		}
	}

	asm {
		mov	si, chan
		mov	al, byte ptr pitch
		mov	byte ptr vPitchBend[si], al
	}

	if(percussion && _SI>=BD && _SI<=HIHAT) {
		if(_SI==BD) {
			SndOutput1(0xA6, pitchL);
			SndOutput1(0xB6, _DI);
		}
	}
	else {
		if(_SI>=11) {
			SndOutput3(0xA0-11+_SI, pitchL);
			SndOutput3(0xB0-11+_SI, voiceKeyOn[_SI]|_DI);
		}
		else {
			SndOutput1(0xA0+_SI, pitchL);
			SndOutput1(0xB0+_SI, voiceKeyOn[_SI]|_DI);
		}
	}
}

int CalcVoicePitch2_SOP(unsigned note, int pitch)
{
	int pitch2;
	_SI=MOD12[note];

	if(pitch < 0 || pitch > 200) return 0;

	if(pitch>=100) pitch2=FreqP[_SI]*(pitch-100)/100;
	else pitch2=FreqM[_SI]*(pitch-100)/100;

	return pitch2;
}

void NoteOn_SOP(unsigned chan, unsigned pitch)
{
	int pitchL;

	_SI=MOD12[(_BX=pitch)];
	_DI=DIV12[_BX];

	if(chan >= maxVoices) return;

	_DX=FreqL[_SI]+vPitchBend[chan];
	pitchL=_DL;

	if(_SI==7) {
		asm {
			xor	ah, ah
			mov	al, byte ptr FreqH[si]
			shl	dh, 1
			sbb	al, 0
			or	di, ax
		}
	}
	else {
		asm {
			xor	ah, ah
			mov	al, byte ptr FreqH[si]
			add	al, dh
			or	di, ax
		}
	}

	_SI=chan;
	voiceKeyOn[_SI]=0x20;

	if(percussion && _SI>=BD && _SI<=HIHAT) {
		if(_SI==BD) {
			SndOutput1(0xA6, pitchL);
			SndOutput1(0xB6, _DI);
		}
		else if(_SI==TOM && voiceNote[TOM]!=pitch) {
			SndOutput1(0xA8, pitchL);
			SndOutput1(0xB8, _DI);

			_DI=DIV12[(_BX=(pitch+TOM_TO_SD))];
			_CX=MOD12[_BX];

			_DX=FreqL[_CX]+vPitchBend[chan];
			pitchL=_DL;

			if(_CX==7) {
				asm {
					mov	bx, cx
					xor	ah, ah
					mov	al, byte ptr FreqH[bx]
					shl	dh, 1
					sbb	al, 0
					or	di, ax
				}
			}
			else {
				asm {
					mov	bx, cx
					xor	ah, ah
					mov	al, byte ptr FreqH[bx]
					add	al, dh
					or	di, ax
				}
			}

			SndOutput1(0xA7, pitchL);
			SndOutput1(0xB7, _DI);
		}
		SndOutput1(0xBD, ymbuf[0x0D]|(0x10>>(_SI-BD)));
	}
	else {
		if(_SI>=11) {
			SndOutput3(0xA0-11+_SI, pitchL);
			SndOutput3(0xB0-11+_SI, 0x20|_DI);
		}
		else {
			SndOutput1(0xA0+_SI, pitchL);
			SndOutput1(0xB0+_SI, 0x20|_DI);
		}
	}

	voiceNote[_SI]=pitch;
}

void NoteOff_SOP(unsigned chan)
{
	if(chan >= maxVoices) return;

	_SI=chan;
	voiceKeyOn[_SI]=0;

	if(percussion && _SI>=BD && _SI<=HIHAT) SndOutput1(0xBD, ymbuf[0x0D]&(0xFF-(0x10>>(_SI-BD))));
	else {
		if(_SI>=11) SndOutput3(0xB0-11+_SI, ymbuf[YMB_SIZE-11+_SI]&0xDF);
		else SndOutput1(0xB0+_SI, ymbuf[_SI]&0xDF);
	}
}

int Set_4OP_Mode(unsigned chan, unsigned value)
{
	if(SlotX[chan+20]<=2) {
		OP4[chan]=value;

		if(value) {
			if(chan>10) OP_MASK|=(0x01<<(chan-11+3));
			else OP_MASK|=(0x01<<chan);
		}
		else {
			if(chan>10) OP_MASK&=(0xFF-(0x01<<(chan-11+3)));
			else OP_MASK&=(0xFF-(0x01<<chan));
		}

		SndOutput3(0x04, OP_MASK);

		return 1;
	}

	return 0;
}

unsigned GetAddr_SOP(void)
{
	return genAddr_SOP;
}